petsc-3.10.5 2019-03-28
Report Typos and Errors

# MatSeqSBAIJSetPreallocation

Creates a sparse symmetric matrix in block AIJ (block compressed row) format. For good matrix assembly performance the user should preallocate the matrix storage by setting the parameter nz (or the array nnz). By setting these parameters accurately, performance during matrix assembly can be increased by more than a factor of 50.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode  MatSeqSBAIJSetPreallocation(Mat B,PetscInt bs,PetscInt nz,const PetscInt nnz[])

Collective on Mat

### Input Parameters

| B | - the symmetric matrix
| bs | - size of block, the blocks are ALWAYS square. One can use MatSetBlockSizes() to set a different row and column blocksize but the row blocksize always defines the size of the blocks. The column blocksize sets the blocksize of the vectors obtained with MatCreateVecs()
| nz | - number of block nonzeros per block row (same for all rows)
| nnz | - array containing the number of block nonzeros in the upper triangular plus diagonal portion of each block (possibly different for each block row) or NULL

### Options Database Keys

-mat_no_unroll -uses code that does not unroll the loops in the block calculations (much slower)
-mat_block_size -size of the blocks to use (only works if a negative bs is passed in

### Notes

Specify the preallocated storage with either nz or nnz (not both). Set nz=PETSC_DEFAULT and nnz=NULL for PETSc to control dynamic memory allocation. See Users-Manual: ch_mat for details.

You can call MatGetInfo() to get information on how effective the preallocation was; for example the fields mallocs,nz_allocated,nz_used,nz_unneeded; You can also run with the option -info and look for messages with the string malloc in them to see if additional memory allocation was needed.

If the nnz parameter is given then the nz parameter is ignored

### See Also

MatCreate(), MatCreateSeqAIJ(), MatSetValues(), MatCreateSBAIJ()

### Level

intermediate

### Location

src/mat/impls/sbaij/seq/sbaij.c

### Examples

src/mat/examples/tutorials/ex17.c.html
src/ksp/ksp/examples/tutorials/ex2.c.html
src/snes/examples/tutorials/ex48.c.html

### Implementations

MatSeqSBAIJSetPreallocation_SeqSBAIJ in src/mat/impls/sbaij/seq/sbaij.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages